package com.eactive.eai.batch.job.jobItem.skt;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.HashMap;
import java.util.Properties;

import com.eactive.eai.batch.common.LogUtil;
import com.eactive.eai.batch.common.StringUtil;
import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobHandle.JobProcessData;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;
import com.eactive.eai.common.exception.ExceptionUtil;

public class SEND_SKT01_0810 extends DefaultTelegram implements TelegramService
{

    private int SEND_LENGTH;        //TCP/IP전문 송신 BYTES수로 "업무구분코드"이후의 송신할 전문 길이
    private int REAL_SEND_LENGTH;  //실제 송신할 전문의 총길이

    private Properties telegramInfo;

    public SEND_SKT01_0810() {
        //개시/종료 전문
    }

    /**
     * 전문조립
     */
    public boolean doExecute() {
        try {
            boolean result = calculateSendLength();
            if (!result) return false;

            //전송길이
            compileField(0, "" + SEND_LENGTH, this.al_FieldProps[0]);

            //TRANSACTION CODE
            compileField(1, telegramInfo.getProperty(TelegramKeys.TRANSACTION_CODE ), this.al_FieldProps[1]);

            //송신기관코드 - 송신기관코드 참조 "7170"
            compileField(2, telegramInfo.getProperty(TelegramKeys.BANK_CODE ), this.al_FieldProps[2]);

            //전문코드(개시/데이터/결번)
            compileField(3, this.getFldTelegramType(), this.al_FieldProps[3]);

            //자료구분코드(파일명) - 기본(19) - 파일명(Full Name): 기관코드(4)+파일ID(6)+구분자(1)+YYYYMMDD(8)
            compileField(4, batchDoc.getBatchMsg().getHeader().getFileName(), this.al_FieldProps[4]);

            //전문고유번호(순번) 각각의 전문은 고유한 6자리의 번호를 갖는다.(각각의 전문을 sequence하게 할당한다.)
            compileField(5, ""+batchDoc.getBatchMsg().getBody().getNodeCount(), this.al_FieldProps[5]);

            //전송일자(YYMMDD)
            compileField(6, TelegramKeys.getYYYYMMDD().substring(2), this.al_FieldProps[6]);

            //전송시각(HH24MISS)
            compileField(7, TelegramKeys.getHHMMSS(), this.al_FieldProps[7]);

            //응답코드
            compileField(8, this.getResolveResponseCode(), this.al_FieldProps[8]);

            //암호 - UNUSED
            compileField(9, "", this.al_FieldProps[9]);

            //RESERVED - UNUSED
            compileField(10, "", this.al_FieldProps[10]);

            //통신망관리정보(001/002/301)
            compileField(11, this.getFldOpCode(), this.al_FieldProps[11]);

            //DATA HEADER - UNUSED
            compileField(12, "", this.al_FieldProps[12]);

            //<< 전문 완성
            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }

    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength()
    {
        try {
            return REAL_SEND_LENGTH;  //실 DATA BYTE수
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI013";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return -1;
        }
    }

    public boolean doPreExecute() {
        try {
            if (!super.doPreExecute()) return false;
            telegramInfo = getTelegramInfo();
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI003";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    public boolean doPostExecute() {
        if (!super.doPostExecute()) return false;
        try {
			//DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<11; i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=11; i< al_Field.size(); i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));

            if (this.getFldOpCode().equals("001")){
				LogUtil.setLogFileStart(batchDoc);
            }else if (this.getFldOpCode().equals("002")){
                //이하 응답코드가 '업무개시'가 아닌 경우에만 처리
                //수신 파일 관련 처리
                String fileDir = batchDoc.getBatchMsg().getHeader().getFilePath();
                String fileNm  = batchDoc.getBatchMsg().getHeader().getFileName();
                if (fileDir.charAt(fileDir.length()-1) != File.separatorChar) {
                    fileDir = fileDir + File.separator;
                }
                String fileName = fileDir + fileNm;

    			File rcvRealFile = new File( fileName );
    			
                String uuid = this.batchDoc.getBatchMsg().getHeader().getUUID();
                int seq_no = this.batchDoc.getBatchMsg().getHeader().getBlockSize();

                JobProcessData job = JobProcessData.getInstance();
                HashMap<String, Object> hm = job.getBatchStageData(uuid);
                @SuppressWarnings("unchecked")
    			HashMap<Integer, byte[]> block_data = (HashMap<Integer, byte[]>)hm.get(JobProcessData.PROCDATA_BLOCKDATA);

    			if ( block_data != null ){
        			//FileOutputStream fout = new FileOutputStream(rcvRealFile, true);
    				try (FileOutputStream fout = new FileOutputStream(rcvRealFile, true)) {// 20250910 obl
	                    for (int i = 0; i<seq_no; i++) {        //받은 seq_no만큼만 데이터 확인하여 기록
	                    	byte[] data = (byte[]) block_data.get(new Integer(i));
	                    	if ( data != null ){
	                    		int recLen = Integer.parseInt(substring(data, 8, 4));
	                    		byte[]layout = new byte[recLen];
	                    		for (int inx = 0; inx < layout.length; inx++) {
	        						layout[inx] = ' ';
	        					}
	
	                    		int dataCnt = Integer.parseInt(substring(data, 4, 4));
	                    		for (int jnx = 0; jnx < dataCnt; jnx++) {
	                        		System.arraycopy( data,jnx*layout.length+12,layout,0,layout.length);
	                                fout.write(layout);
	                                fout.write( '\n' );
	                                long lnCurSize = batchDoc.getBatchMsg().getBody().getCurFileSize()+recLen;
	                                batchDoc.getBatchMsg().getBody().setCurFileSize(lnCurSize);
	                                batchDoc.getBatchMsg().getHeader().setFileSize(lnCurSize);
	        					}
	                    		
	                    	}
	                		
	                    }
	                    //fout.close();
	                    hm.put(JobProcessData.PROCDATA_BLOCKDATA, null);    //데이터 기록후 Vector 초기화
    				} catch (IOException e) {
    			        logger.error(e.getMessage(), e);
    			    }
    			}
    			
    			File rcvArchFile = new File( StringUtil.realToArchDir(fileName) );
    			File rcvRootFile = new File( StringUtil.realToRootDir(fileName) );

                if ((fileNm != null) && (!fileNm.trim().equals(""))&& (rcvRealFile.exists())) {

    				//DB로그에 남길 파일 헤더,트레일러 내용 설정
    				super.setFileHeaderAndTrailer(rcvRealFile);

    				//수신 Real 디렉토리 -> Arch 디렉토리로 파일 이동 (파일명 변경 안한고 동일 파일명 존재시 Overwrite)
    				logger.info("{} >>>>> 수신 파일을 수신 Real 디렉토리 -> 수신 Arch 디렉토리로 이동.....", logHeader);
    				boolean isSuccessMoveFile = rcvRealFile.renameTo(rcvArchFile);
    				if (!isSuccessMoveFile) {
    					String errMsg = ExceptionUtil.getErrorCode("BECEAIFJI030", new String[] {rcvRealFile.getAbsolutePath(), rcvArchFile.getAbsolutePath()});
    					batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);	//수신 파일을 수신 Real 디렉토리에서 수신 Arch 디렉로 이동시 오류가 발생하였습니다. [Real Path: {1}] [Arch Path: {2}]
    					super.setResolveResponseCode("99");
    					return true;  //다음단계 수행시 응답코드를 기준으로 에러전문을 송신하기위해 true 설정함
    				}
    				//DB로그에 남길 변경 파일명 설정 (파일명 변경 안함)
    				batchDoc.getBatchMsg().getHeader().setRenamedFileName(fileName);
    				
    				logger.info("{} >>>>> 수신 파일과 동일 파일명의 0 Byte 파일을 Root 디렉토리에 생성......(HOST에 자동 송신하도록 수신 File Event 발생)", logHeader);	
        			try {
        				isSuccessMoveFile = rcvRootFile.createNewFile();
    				} catch (Exception e) { } // 실패인 경우 무시하고 로깅만 하도록....
        			
        			if (!isSuccessMoveFile) {
        				String errMsg = ExceptionUtil.getErrorCode("BECEAIFJI031", new String[] {rcvRootFile.getAbsolutePath()});
        				batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);	//수신 Root 디렉토리에 0 Byte 파일을 생성할 수 없습니다. [Path: {1}]
        			}

    				//수신 파일 End DB로그
    				LogUtil.setLogFileEnd(batchDoc);
               }
            }


            return true;

        } catch(Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    private boolean calculateSendLength () {
        try {
        	for (int i=1; i< this.al_Field.size(); i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                SEND_LENGTH += aField.length;
            }
        	REAL_SEND_LENGTH = SEND_LENGTH + ((byte[]) this.al_Field.get(0)).length;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI025";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }

    /**
     * int getCalculatedLength(int idx)
     * --------------------------------------------------------------------------------------
     * 전달된 인덱스 idx는 비정형 필드여야 한다. 즉 필드의 길이값이 FILE_NO_LENGTH("XX") 이어야 한다.
     * 해당 비정형 필드에 대해 실질적인 전문길이를 동적으로 계산해 낸다.
     */
    public int getCalculatedLength(int idx) {

    	if (idx >= this.getFieldCount()) {
            logger.debug("{} getCalculatedLength> parameter is bigger than field count", logHeader);
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI011";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }
        if (!this.getFieldLength(idx).equalsIgnoreCase(TelegramService.FIELD_NO_LENGTH)) {
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI012";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }
        return -1;

    }
    
    public int getInformalFieldSendData(int idx, byte[] data) {
    	int fldLen = getCalculatedLength(idx);
        try {
            if (idx >= this.getFieldCount() ) {
                logger.debug("{}  getInformalFieldSendData> " +idx+ " is bigger than field count", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI011";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            if (data.length < fldLen) {
                logger.debug("{}  getInformalFieldSendData> InformalFieldSendData size is bigger than buffer size", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI014";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            return fldLen;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI006";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return -1;
        }
    }

    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
		return super.getFieldValueString(3);
    }
    // 거래구분코드 필드값 리턴
//    public String getTrClass()
//    {
//		return super.getFieldValueString(5);
//    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
		return super.getFieldValueString(8);
    }
    //업무관리코드 필드값 리턴
    public String getOpCode()
    {
		return super.getFieldValueString(11);
    }


}

